! Print permutations of a string
! Copyright (C) 2003 Nils M Holm.  All rights reserved.
! See the file LICENSE of the T3X distribution
! for conditions of use.

module permute(t3x, string);

object	t[t3x], str[string];

const	MAX = 10;	! Maximum string length

! Permute the last k-n characters of the string s,
! where k is the length of s; print all permutations
permute(s, k, n) do
	var	i, j, u;
	var	done::MAX, m;
	var	nl::3;

	m := 0;
	! Empty suffix: print the only permutation
	ie (k = n) do
		t.write(T3X.SYSOUT, s, str.length(s));
		t.write(T3X.SYSOUT, t.newline(nl), str.length(nl));
	end
	! Non-empty suffix: compute all permutations
	else for (i=n, k) do
		! Has the current character already been swapped?
		for (j=0, m) if (s::i = done::j) leave;
		! If not, this permutation is new
		if (j = m) do
			! Swap s::i <-> s::n
			u := s::i; s::i := s::n; s::n := u;
			! Permute the suffix
			permute(s, k, n+1);
			! Restore the original string
			u := s::i; s::i := s::n; s::n := u;
			! Memorize the swapped character
			done::m := s::i; m := m+1;
		end
	end
end

do var input::MAX+1, k;
	k := t.read(T3X.SYSIN, input, MAX+1);	! Read string
	k := k-1;				! Strip newline character
	if (k > 0 /\ input::(k-1) = '\r')	! Strip CR, if present
		k := k-1;
	if (k > 0) input::k := 0;		! Delimit string
	if (k > 0) permute(input, k, 0);
end
