! Compute and print prime numbers
! Copyright (C) 2003 Nils M Holm.  All rights reserved.
! See the file LICENSE of the T3X distribution
! for conditions of use.

module primes(t3x, string);

object	t[t3x], str[string];

! write string
writes(s) t.write(T3X.SYSOUT, s, str.length(s));

! write newline sequence
newline() do var nl::3;
	writes(t.newline(nl));
end

do
	const	MAX=1000;	! Number of primes to compute
	var	primes[MAX];	! Array of primes found so far
	var	i, p, top, ok;
	var	buf::10;

	primes[0] := 2;		! Pre-set the first prime
	writes("2"); newline();	! and print it
	top := 1;		! Number of primes found so far
	p := 3;			! Next number to test
	while (top<MAX) do
		ok := 1;		! Assume that p is prime
		for (i=0,top) do
			! Can p be divided by any of the
			! primes found so far
			if (\(p mod primes[i])) do
				ok := 0;	! If so, p cannot be prime
				leave;		! No further tests required
			end
		end
		if (ok) do
			! If p is prime, print it.
			writes(str.numtostr(buf, p, 10)); newline();
			! and add it to the array of primes
			primes[top] := p;
			top := top+1;
		end
		! Test the next odd number
		p := p+2;
	end
end
