! TTT -- an implementation of Tic Tac Toe
! -- Uncommented version --
! Copyright (C) 2003 Nils M Holm.  All rights reserved.
! See the file LICENSE of the T3X distribution
! for conditions of use.

module ttt_plain(t3x, ttyctl);

object	t[t3x], tty[ttyctl];

var	Field[9];
var	Moves;

init() do
	Moves := [
		[ [0,2,2], [2,2,2] ],
		[ [2,0,2], [2,2,2] ],
		[ [2,2,0], [2,2,2] ],
		[ [0,1,1], [2,1,1] ],
		[ [1,0,1], [1,2,1] ],
		[ [1,1,0], [1,1,2] ],
		[ [0,1,0], [2,1,0] ],
		[ [0,0,1], [0,2,1] ],
		[ [1,0,0], [1,2,0] ],
		[ [0,1,2], [2,1,2] ],
		[ [0,2,1], [2,2,1] ],
		[ [1,0,2], [1,2,2] ],
		[ [1,2,0], [1,2,2] ],
		[ [2,0,1], [2,2,1] ],
		[ [2,1,0], [2,1,2] ],
		[ [0,0,2], [2,0,2] ],
		[ [0,2,0], [2,2,0] ],
		[ [2,0,0], [2,0,2] ],
		[ [0,0,0], [0,2,0] ],
		0
	];
	tty.init();
	tty.mode(1);
	tty.clear();
	t.memfill(Field, 0, 9*t.bpw());
end

fini() do
	tty.move(0, 12);
	tty.mode(0);
	tty.fini();
	halt 0;
end

drawframe() do
	tty.move(8, 4); tty.writes("   |   |   ");
	tty.move(8, 5); tty.writes("---+---+---");
	tty.move(8, 6); tty.writes("   |   |   ");
	tty.move(8, 7); tty.writes("---+---+---");
	tty.move(8, 8); tty.writes("   |   |   ");
end

drawfield() do var i, j;
	for (j=0, 3) do
		for (i=0, 3) do
			tty.move(9+4*i, 4+2*j);
			tty.writec(Field[j*3+i] = 1 -> 'X':
				Field[j*3+i] = 2 -> 'O': '\s');
		end
	end
end

match(fp0, fp1, fp2, rule) do var p, q;
	p := rule[0];
	q := rule[1];
	if (fp0[0] = p[0] /\ fp1[0] = p[1] /\ fp2[0] = p[2]) do
		fp0[0] := q[0];
		fp1[0] := q[1];
		fp2[0] := q[2];
		return 1;
	end
end

move(n) do var i;
	Field[n] := 1;
	if (Field[4] = 0) do
		Field[4] := 2;
		drawfield();
		return;
	end
	i := 0;
	while (Moves[i]) do
		if (match(@Field[0], @Field[4], @Field[8], Moves[i])) leave;
		if (match(@Field[2], @Field[4], @Field[6], Moves[i])) leave;
		if (match(@Field[0], @Field[1], @Field[2], Moves[i])) leave;
		if (match(@Field[3], @Field[4], @Field[5], Moves[i])) leave;
		if (match(@Field[6], @Field[7], @Field[8], Moves[i])) leave;
		if (match(@Field[0], @Field[3], @Field[6], Moves[i])) leave;
		if (match(@Field[1], @Field[4], @Field[7], Moves[i])) leave;
		if (match(@Field[2], @Field[5], @Field[8], Moves[i])) leave;
		i := i+1;
	end
	drawfield();
	if (i < 3) do
		tty.move(8, 10);
		tty.writes("Oops!");
		fini();
	end
end

select() do var i, j, k;
	for (i=0, 9) if (\Field[i]) leave;
	j := i / 3;
	i := i mod 3;
	while (1) do
		tty.move(9+4*i, 4+2*j);
		k := tty.readc();
		ie (k = 'l' \/ k = ttyctl.K_RIGHT) do
			i := i+1;
			if (i > 2) i := 0;
		end
		else ie (k = 'h' \/ k = ttyctl.K_LEFT) do
			i := i-1;
			if (i < 0) i := 2;
		end
		else ie (k = 'j' \/ k = ttyctl.K_DOWN) do
			j := j+1;
			if (j > 2) j := 0;
		end
		else ie (k = 'k' \/ k = ttyctl.K_UP) do
			j := j-1;
			if (j < 0) j := 2;
		end
		else ie (k = '\r') do
			ie (Field[j*3+i])
				tty.writec('\a'); 
			else
				leave;		  
		end
		else if (k = ttyctl.K_ESC \/ k = 'q') do
			fini();
		end
	end
	return j*3+i;
end

do var i;
	init();
	drawframe();
	for (i=0, 5) move(select());
	fini();
end
